using System;
using System.Collections;
using System.ComponentModel;
using System.Configuration.Install;
using System.ServiceProcess;

namespace RepoCleanup
{
	/// <summary>
	/// Installer. Generated. Updated method: constructor.<br/>
	/// Install the Windows service with installutil.
	/// <p>Copyright (c) 2002 Alexis Grandemange<br/>
	/// Mail: alexis.grandemange@pagebox.net</p>
	/// <pre>This program is free software; you can redistribute it and/or
	/// modify it under the terms of the GNU Lesser General Public
	/// License as published by the Free Software Foundation; version
	/// 2.1 of the License.
	/// This library is distributed in the hope that it will be useful,
	/// but WITHOUT ANY WARRANTY; without even the implied warranty of
	/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	/// GNU Lesser General Public License for more details.
	/// A copy of the GNU Lesser General Public License lesser.txt should be
	/// included in the distribution.</pre>
	/// </summary>
	[RunInstaller(true)]
	public class ProjectInstaller : System.Configuration.Install.Installer
	{
		private System.ServiceProcess.ServiceProcessInstaller CleanupProcessInstaller;
		private System.ServiceProcess.ServiceInstaller CleanupInstaller;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ProjectInstaller()
		{
			// This call is required by the Designer.
			InitializeComponent();

			// 
			// CleanupProcessInstaller
			//
			Console.WriteLine("======= RepoCleanup installation =======");
			Console.WriteLine("Enter the Windows service user name (machine\\user):");
			this.CleanupProcessInstaller.Username = Console.ReadLine();
			Console.WriteLine("Enter the Windows service user password:");
			this.CleanupProcessInstaller.Password = Console.ReadLine();
			// 
			// CleanupInstaller
			// 
			this.CleanupInstaller.ServiceName = "Cleanup";
			this.CleanupInstaller.StartType = ServiceStartMode.Manual;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		public override void Dispose()
		{
			if (components != null) 
			{
				components.Dispose();
			}
			base.Dispose();
		}

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.CleanupProcessInstaller = new System.ServiceProcess.ServiceProcessInstaller();
			this.CleanupInstaller = new System.ServiceProcess.ServiceInstaller();
			// 
			// ProjectInstaller
			// 
			this.Installers.AddRange(new System.Configuration.Install.Installer[] {
																					  this.CleanupProcessInstaller,
																					  this.CleanupInstaller});

		}
	}
}
